package com.webreference.i18nsupport;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

/**
 * Servlet implementation class for Servlet: i18nsupportServlet
 *
 */
 public class I18nSupportServlet extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
   static final long serialVersionUID = 1L;
   
    /* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#HttpServlet()
	 */
	public I18nSupportServlet() {
		super();
	}   	
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) 
			throws ServletException, IOException {
		String action  = request.getParameter("action");
		String sLocale = request.getParameter("locale");
		ResourceBundle 	labels 		= null;
		String 			strResponse = "";
		
		try 
		{
			String localParts[] = sLocale.split("_");
			Locale newLocale = new Locale(localParts[0], localParts[1]);
			labels = ResourceBundle.getBundle("resources.labels", newLocale);

			if ("change_locale".equals(action)) 
	        {	
				String keys = request.getParameter("keys");
				try 
				{
					JSONArray 	aKeys 		= new JSONArray(keys);
					JSONArray 	outValues 	= new JSONArray();
					JSONObject 	jsonOption 	= null;
					String 		key 		= null;
					
					for (int i=0; i<aKeys.length();i++) {  
						key = (String)aKeys.get(i);
				        jsonOption = new JSONObject();
				        jsonOption.put(key, labels.getString("language."+key+".value"));
				        outValues.put(jsonOption);
				    }
					strResponse = outValues.toString();
				} 
				catch (JSONException e) 
				{
					response.getWriter().write( "\"" + e.getMessage() + "\"" );
				}
				/*
				JSONObject JsonLabels = new JSONObject();
				
				Enumeration<String> bundleKeys = labels.getKeys();

				try 
				{
					while (bundleKeys.hasMoreElements()) 
					{
					    String key = (String)bundleKeys.nextElement();
					    String value = labels.getString(key);
					    JsonLabels.put(key, value);
					}
					
					strResponse = JsonLabels.toString(2);
				} 
				catch (JSONException e) 
				{
					//enclose the error message in quotes.
					response.getWriter().write( "\"" + e.getMessage() + "\"" );
				}
				*/
	        }
			else if ("fetch_label".equals(action))
			{
				String key = request.getParameter("key");
				strResponse = labels.getString(key);
				if (strResponse == null) strResponse = key;
			}
		} 
		catch (java.util.MissingResourceException e) 
		{
			//enclose the error message in quotes.
			response.getWriter().write( "\"" + e.getMessage() + "\"" );
			return;
		}
				
		response.setCharacterEncoding("UTF-8");
		response.setContentType("text/plain");
		response.setHeader("Cache-Control", "no-cache");
		response.getWriter().write( strResponse );
	}  	
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	}   	  	    
}